//---------------------------------------------------------------------------

#ifndef CustomProgressBarH
#define CustomProgressBarH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>

#include "colorset.h"

const AnsiString empty = "";
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
class PACKAGE TCustomProgressBar : public TLabel
{
private:
        Graphics::TBitmap *mbm;
        Graphics::TBitmap *fIcon;

        int fminval, fmaxval, fcurval;
        int fokval, fwarval;
        int flineheight;
        int fl_offset, ft_offset, fb_offset, fr_offset;
        int fborderwidth;

        bool fdrawlabels;
        bool fflat;
        bool fsolid;

        TColor fbkgColor, ftxtColor;

        AnsiString fSign;

        void __fastcall SetMinVal( int newval ) {
                fminval = newval;
                if ( fmaxval < newval ) fmaxval = newval;
                if ( fcurval < newval ) fcurval = newval;
                Repaint();
        }
        void __fastcall  SetMaxVal( int newval ) {
                fmaxval = newval;
                if ( fminval > newval ) fminval = newval;
                if ( fcurval > newval ) fcurval = newval;
                Repaint();
        }
        void __fastcall  SetCurVal( int newval ) {
                fcurval = newval;
                if ( fcurval > fmaxval ) fcurval = fmaxval;
                if ( fcurval < fminval ) fcurval = fminval;
                Repaint();
        }
        void __fastcall  SetOkVal( int newval ) {
                fokval = newval;
                if ( fokval > fmaxval ) fokval = fmaxval;
                if ( fokval < fminval ) fokval = fminval;
                Repaint();
        }
        void __fastcall  SetWarVal( int newval ) {
                fwarval = newval;
                if ( fwarval > fmaxval ) fwarval = fmaxval;
                if ( fwarval < fminval ) fwarval = fminval;
                Repaint();
        }

        void __fastcall  SetLineH( int newval ) {
                flineheight = newval;
                Repaint();
        }
        void __fastcall  SetLOffset( int newval ) {
                fl_offset = newval;
                Repaint();
        }
        void __fastcall  SetROffset( int newval ) {
                fr_offset = newval;
                Repaint();
        }
        void __fastcall  SetTOffset( int newval ) {
                ft_offset = newval;
                Repaint();
        }
        void __fastcall  SetBOffset( int newval ) {
                fb_offset = newval;
                Repaint();
        }
        void __fastcall  SetBorderWidth( int newval ) {
                fborderwidth = newval;
                Repaint();
        }
        void __fastcall  SetBkgColor( TColor newcol ) {
                fbkgColor = newcol;
                Repaint();
        }
        void __fastcall  SetTxtColor( TColor newcol ) {
                ftxtColor = newcol;
                Repaint();
        }
        void __fastcall  SetSign( AnsiString newsign ) {
                fSign = newsign;
                Repaint();
        }
        void __fastcall  SetIcon( Graphics::TBitmap *newIcon ) {
                Height = Height - fIcon->Height;
                bottom_offset = bottom_offset - fIcon->Height;
                fIcon->Assign(newIcon);
                Height = Height + fIcon->Height;
                bottom_offset = bottom_offset + fIcon->Height;
                Repaint();
        }
        void __fastcall  SetDrawLabels( bool newval ) {
                fdrawlabels = newval;
                Repaint();
        }
        void __fastcall  SetFlat( bool newval ) {
                fflat = newval;
                Repaint();
        }
        void __fastcall  SetSolid( bool newval ) {
                fsolid = newval;
                Repaint();
        }

protected:
        void __fastcall DrawBackGround() {
                if (!mbm) return;
                mbm->Canvas->Brush->Color = fbkgColor;
                mbm->Canvas->FillRect(Rect(0, 0, Width - 1, Height -1 ));
        }
        void __fastcall DrawBorder() {
                if (!mbm) return;
                mbm->Canvas->Pen->Width = fborderwidth;
                if (!flat)
                        mbm->Canvas->Pen->Color = clBtnShadow;
                else
                        mbm->Canvas->Pen->Color = bkgColor;
                mbm->Canvas->MoveTo(0,0);
                mbm->Canvas->LineTo(0,Height - 1);
                mbm->Canvas->MoveTo(0,0);
                mbm->Canvas->LineTo(Width - 1,0);

                if (!flat)
                        mbm->Canvas->Pen->Color = clWhite;
                else
                        mbm->Canvas->Pen->Color = bkgColor;
                mbm->Canvas->MoveTo(Width - 1,Height - 1);
                mbm->Canvas->LineTo(Width - 1,1);
                mbm->Canvas->MoveTo(Width - 1,Height - 1);
                mbm->Canvas->LineTo(1,Height - 1);
        }
        void __fastcall DrawLines() {
                if (!mbm) return;
                mbm->Canvas->Pen->Width = flineheight;

                int count = ( Height - ft_offset - fb_offset - flineheight )/( flineheight  + ( solid ? 0 : 1 ) ) + 1;
                int ov = ( fmaxval - fminval > 0 ) ? count*( fokval - fminval )/( fmaxval - fminval ) : 0;
                int wv = ( fmaxval - fminval > 0 ) ? count*( fwarval - fminval )/( fmaxval - fminval ) : 0;

                for (int i = 0; i < count; i ++) {
                        if ( i < ov )
                                mbm->Canvas->Pen->Color = (TColor)GREEN6;//0x0099BBAA;
                        else if ( i < wv )
                                mbm->Canvas->Pen->Color = (TColor)YELLOW5;//0x00AACCDD;
                        else
                                mbm->Canvas->Pen->Color = (TColor)RED6;//0x00AAAADD;
                        mbm->Canvas->MoveTo(fl_offset + flineheight/2, Height - fb_offset - ( flineheight + ( solid ? 0 : 1 ))*i - flineheight/2);
                        mbm->Canvas->LineTo(Width - fr_offset - flineheight/2 - fborderwidth, Height - fb_offset - ( flineheight + ( solid ? 0 : 1 ))*i - flineheight/2);
                }

                int cv = ( fmaxval - fminval > 0 ) ? count*( fcurval - fminval )/( fmaxval - fminval ) : 0;
                for (int i = 0; i < cv ; i ++) {
                        if ( cv <= ov)
                                mbm->Canvas->Pen->Color = (TColor)GREEN4;//0x0022BB22;
                        else if ( cv <= wv )
                                mbm->Canvas->Pen->Color = (TColor)YELLOW1;//0x0044CCDD;
                        else
                                mbm->Canvas->Pen->Color = (TColor)RED4;//0x008888FF;
                        mbm->Canvas->MoveTo(fl_offset + flineheight/2 , Height - fb_offset - ( flineheight + ( solid ? 0 : 1 ))*i - flineheight/2);
                        mbm->Canvas->LineTo(Width - fr_offset - flineheight/2 - fborderwidth, Height - fb_offset - ( flineheight + ( solid ? 0 : 1 ) )*i - flineheight/2);
                }

                if (Divided)
                {
                    mbm->Canvas->Pen->Color = bkgColor;
                    mbm->Canvas->Pen->Width = flineheight;
                    mbm->Canvas->MoveTo(Width / 2, Height - fb_offset);
                    mbm->Canvas->LineTo(Width / 2, Height - fb_offset - ( flineheight + ( solid ? 0 : 1 ) )*count - flineheight/2);
                }
        }
        void __fastcall DrawText() {
                if (!mbm) return;
                int OldBkMode = SetBkMode(mbm->Canvas->Handle, TRANSPARENT);

                mbm->Canvas->Font->Color = ftxtColor;
                mbm->Canvas->Font->Name = Font->Name;//"Curier New";
                mbm->Canvas->Font->Size = Font->Size - 2;//8;
                mbm->Canvas->Font->Style = TFontStyles();

                int Base = Height - fb_offset;

                if ( draw_labels ) {
                        int count = ( Height - ft_offset - fb_offset - flineheight )/( flineheight  + 1 ) + 1;

                        int lv = ( fmaxval - fminval > 0 ) ? count*( fminval - fminval )/( fmaxval - fminval ) : 0;
                        int ov = ( fmaxval - fminval > 0 ) ? count*( fokval - fminval )/( fmaxval - fminval ) : 0;
                        int wv = ( fmaxval - fminval > 0 ) ? count*( fwarval - fminval )/( fmaxval - fminval ) : 0;
                        int hv = ( fmaxval - fminval > 0 ) ? count*( fmaxval - fminval )/( fmaxval - fminval ) : 0;

                        mbm->Canvas->TextOutA( fl_offset - ( mbm->Canvas->Font->Size/2 + 1)*(IntToStr(min_val).Length() + 1) - 1, Base - lv*(flineheight  + 1) - mbm->Canvas->Font->Size - 2, IntToStr(min_val));
                        mbm->Canvas->TextOutA( fl_offset - ( mbm->Canvas->Font->Size/2 + 1)*(IntToStr(ok_val).Length() + 1) - 1, Base - ov*(flineheight  + 1) - mbm->Canvas->Font->Size/2, IntToStr(ok_val));
                        mbm->Canvas->TextOutA( fl_offset - ( mbm->Canvas->Font->Size/2 + 1)*(IntToStr(war_val).Length() + 1) - 1, Base - wv*(flineheight  + 1) - mbm->Canvas->Font->Size/2 + 2, IntToStr(war_val));
                        mbm->Canvas->TextOutA( fl_offset - ( mbm->Canvas->Font->Size/2 + 1)*(IntToStr(max_val).Length() + 1) - 1, Base - hv*(flineheight  + 1), IntToStr(max_val));
                }

                mbm->Canvas->Font->Size = Font->Size;
                mbm->Canvas->Font->Color = Font->Color;
                mbm->Canvas->Font->Style = TFontStyles();//TFontStyles() << fsBold;
                AnsiString s;
                s.printf(DisplayFormat.c_str(), cur_val);
                int w = mbm->Canvas->TextWidth(s);
                mbm->Canvas->TextOutA( ( Width - w) / 2, Base + mbm->Canvas->Font->Size/4, s);

                SetBkMode(mbm->Canvas->Handle, OldBkMode);
        }
        void __fastcall DrawCaption() {
                if (!mbm) return;
                int OldBkMode = SetBkMode(mbm->Canvas->Handle, TRANSPARENT);

                mbm->Canvas->Font->Size = Font->Size;
                mbm->Canvas->Font->Color = Font->Color;
                mbm->Canvas->Font->Style = Font->Style;
                int w = mbm->Canvas->TextWidth(Caption);
                mbm->Canvas->TextOutA( ( Width - w) / 2/*( mbm->Canvas->Font->Size/2 )*Caption.Length() + 1)/2 - 3*/, top_offset - mbm->Canvas->Font->Size*2, Caption);

                SetBkMode(mbm->Canvas->Handle, OldBkMode);
        }
        void __fastcall DrawIcon() {
                mbm->Canvas->Draw( (Width - fIcon->Width)/2, Height - fb_offset + 2*mbm->Canvas->Font->Size,fIcon);
        }
        void __fastcall LabPaint(TMessage &Msg) {
                if ( Width < fl_offset + fr_offset + flineheight) Width = fl_offset + fr_offset + flineheight;
                if ( Height < ft_offset + fb_offset + ( flineheight + 1 )*6 ) Height = ft_offset + fb_offset + ( flineheight + 1 )*6;
                if (!mbm) return;
                mbm->Width = Width;
                mbm->Height = Height;
                DrawBackGround();
                DrawBorder();
                DrawLines();
                DrawText();
                DrawIcon();
                DrawCaption();
                Canvas->Draw(0,0,mbm);
        }
        LRESULT ERBKGHandler(TWMEraseBkgnd &Msg) { return -1; }

#define COLOR(X)\
		TColor m_##X;\
        TColor __fastcall Get##X() const\
        {\
        	return m_##X;\
        }\
        void __fastcall Set##X(TColor color)\
        {\
        	m_##X = color;\
        }\

        COLOR(GREEN4)
        COLOR(GREEN6)

        COLOR(RED4)
        COLOR(RED6)

        COLOR(YELLOW1)
        COLOR(YELLOW5)

        AnsiString m_DisplayFormat;

        AnsiString __fastcall GetDisplayFormat() const
        {
        	return m_DisplayFormat;
        }
        void __fastcall SetDisplayFormat(AnsiString DisplayFormat)
        {
        	m_DisplayFormat = DisplayFormat;
        }

        bool m_bDivided;

        bool __fastcall GetDivided() const
        {
        	return m_bDivided;
        }
        void __fastcall SetDivided(bool bDivided)
        {
        	m_bDivided = bDivided;
        }

public:
        __fastcall TCustomProgressBar(TComponent* Owner);
        virtual __fastcall ~TCustomProgressBar( void ) { delete mbm; delete fIcon; }

BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_ERASEBKGND,TWMEraseBkgnd,ERBKGHandler);
        MESSAGE_HANDLER(WM_PAINT,TMessage,LabPaint);
END_MESSAGE_MAP(TLabel);

__published:
        __property int min_val = {read = fminval, write = SetMinVal, default = 0};
        __property int max_val = {read = fmaxval, write = SetMaxVal, default = 100};
        __property int cur_val = {read = fcurval, write = SetCurVal, default = 0};
        __property int ok_val = {read = fokval, write = SetOkVal, default = 50};
        __property int war_val = {read = fwarval, write = SetWarVal, default = 75};

        __property AnsiString Sign = {read = fSign, write = SetSign};

        __property int line_height = {read = flineheight, write = SetLineH, default = 5};
        __property int left_offset = {read = fl_offset, write = SetLOffset, default = 28};
        __property int right_offset = {read = fr_offset, write = SetROffset, default = 15};
        __property int top_offset = {read = ft_offset, write = SetTOffset, default = 10};
        __property int bottom_offset = {read = fb_offset, write = SetBOffset, default = 35};

        __property int border_width = {read = fborderwidth, write = SetBorderWidth, default = 1};

        __property bool draw_labels = {read = fdrawlabels, write = SetDrawLabels, default = true};
        __property bool flat = {read = fflat, write = SetFlat, default = false};
        __property bool solid = {read = fsolid, write = SetSolid, default = false};

        __property Graphics::TBitmap *Icon = {read = fIcon, write = SetIcon};

        __property TColor bkgColor = {read = fbkgColor, write = SetBkgColor, default = (TColor)0x00804000};
        __property TColor labColor = {read = ftxtColor, write = SetTxtColor, default = (TColor)0x00FFFFFF};

        __property TColor GREEN4 = {read = GetGREEN4, write = SetGREEN4, default = (TColor)RGB(150,185,150)};
        __property TColor GREEN6 = {read = GetGREEN6, write = SetGREEN6, default = (TColor)RGB(187,210,187)};

        __property TColor YELLOW1 = {read = GetYELLOW1, write = SetYELLOW1, default = (TColor)RGB(219,219,51)};
        __property TColor YELLOW5 = {read = GetYELLOW5, write = SetYELLOW5, default = (TColor)RGB(239,239,171)};

        __property TColor RED4 = {read = GetRED4, write = SetRED4, default = (TColor)RGB(219,150,150)};
        __property TColor RED6 = {read = GetRED6, write = SetRED6, default = (TColor)RGB(231,187,187)};

        __property AnsiString DisplayFormat = {read = GetDisplayFormat, write = SetDisplayFormat};
        __property bool Divided = {read = GetDivided, write = SetDivided, default = false};
};
//---------------------------------------------------------------------------
#endif
