#define _WIN32_WINNT 0x0500

#include <windows.h>
#include <stdio.h>
#include <malloc.h>
#include <Dbghelp.h>
#include <Tlhelp32.h>
//#include <shlwapi.h>
//#include <shellapi.h>

#include "C:\Program Files\Microsoft Visual Studio .NET 2003\Visual Studio SDKs\DIA SDK\include\CVconst.h"
/*#include "Allocators.h"
#include "Ver.h"*/
#include "Debug.h"

#pragma comment(lib,"Dbghelp.lib")
//#pragma comment(lib,"shell32.lib")
//#pragma comment(lib,"PsAPI.lib")
//#pragma comment(lib,"comsupp.lib")


using namespace DebugSys;

PSTR WriteMiniCallStack(PSTR pStr, DWORD dwEBP, DWORD dwPID, HANDLE hProcess, DWORD dwMaxDeep)
{
	CRemotePtr<DWORD>	EBP(hProcess,(LPDWORD)dwEBP);
	PSTR				pS			= pStr;
	DWORD				dwDeep		= 0;
	
	while(true)
	{
		CRemotePtr<DWORD>	pPrevEBP			= EBP;			// *pPrevEBP   EBP
		CRemotePtr<DWORD>	pRetAddress			= EBP+1;		//return address
		DWORD				dwRetAddress		= 0;

		if(!pPrevEBP || !pRetAddress)
			break;

		dwRetAddress= (DWORD)*pRetAddress;
		pRetAddress = (LPDWORD)*pRetAddress;

		if (!pRetAddress)
			break;

		if (!dwDeep)
			pS += sprintf(pS,"RAW CallStack : \r\n");
		
		//
		pS +=sprintf(pS,"  0x%08X ",dwRetAddress);
		pS = AddressInfo(pS,(PVOID)dwRetAddress, dwPID, hProcess);
		pS +=sprintf(pS,"\r\n");

		EBP = (LPDWORD)*pPrevEBP;

		if (++dwDeep>dwMaxDeep)
		{
			pS += sprintf(pS,"Callstack too deep\r\n");
			break;
		}
	}
	return pS;
}



PSTR FormatOutputValue(PSTR			psBuffer,
					   BasicType	btType,
					   DWORD64		qwLength,
					   PVOID		pvAddr,
					   HANDLE		hProcess)
{
	switch (btType)
	{
	case btBool:
	case btVoid:
	case btVariant:
		break;

	case btInt:
	case btLong:
		if (qwLength == 1)
			psBuffer += sprintf( psBuffer, " = 0x%02X (int8 = %i)",		*CRemotePtr<__int8>(hProcess,pvAddr),	(int)*CRemotePtr<__int8>(hProcess,pvAddr));
		else if (qwLength == 2)
			psBuffer += sprintf( psBuffer, " = 0x%04X (int16 = %i)",	*CRemotePtr<__int16>(hProcess,pvAddr),	(int)*CRemotePtr<__int16>(hProcess,pvAddr));
		else if (qwLength == 4)
			psBuffer += sprintf( psBuffer, " = 0x%08X (int32 = %i)",	*CRemotePtr<__int32>(hProcess,pvAddr),	*CRemotePtr<__int32>(hProcess,pvAddr));
		else if (qwLength == 8)
			psBuffer += sprintf( psBuffer, " = 0x%016I64X (int64 = %i)",*CRemotePtr<__int64>(hProcess,pvAddr),	*CRemotePtr<__int64>(hProcess,pvAddr));
		break;

	case btUInt:
	case btULong:
		if (qwLength == 1)
			psBuffer += sprintf( psBuffer, " = 0x%02X (uint8)",		*CRemotePtr<unsigned __int8>(hProcess,pvAddr));
		else if (qwLength == 2)
		{
			WORD	w = *CRemotePtr<WORD>(hProcess,pvAddr);

			if (w>=32 && w<=126)
				psBuffer += sprintf( psBuffer, " = 0x%04X (uint16=\'%c\')",w,w);
			else
				psBuffer += sprintf( psBuffer, " = 0x%04X (uint16)",w);
		}	
		else if (qwLength == 4)
			psBuffer += sprintf( psBuffer, " = 0x%08X (uint32)",	*CRemotePtr<unsigned __int32>(hProcess,pvAddr));
		else if (qwLength == 8)
			psBuffer += sprintf( psBuffer, " = 0x%016I64X (uint64)",*CRemotePtr<unsigned __int64>(hProcess,pvAddr));
		break;

	case btFloat:
		if (qwLength == 4)
			psBuffer += sprintf(psBuffer," = %f (float32)",	 *CRemotePtr<float>(hProcess,pvAddr));
		if (qwLength == 8)
			psBuffer += sprintf(psBuffer," = %lf (float64)", *CRemotePtr<double>(hProcess,pvAddr));
		if (qwLength == 10)
			psBuffer += sprintf(psBuffer," = %lf (float80)", *CRemotePtr<long double>(hProcess,pvAddr));
		break;

	case btHresult:
		psBuffer += sprintf(psBuffer," = 0x%08X (HRESULT) ->", *CRemotePtr<HRESULT>(hProcess,pvAddr));
		FormatMessageA( FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_FROM_HMODULE | FORMAT_MESSAGE_MAX_WIDTH_MASK,
			GetModuleHandleA( "NTDLL.DLL" ),
			*CRemotePtr<HRESULT>(hProcess,pvAddr),
			MAKELANGID(LANG_ENGLISH,SUBLANG_DEFAULT),			//LANG ID
			psBuffer, 128,
			0 );
		psBuffer += strlen(psBuffer);
		break;

	case btChar:
		if (qwLength == 1)
		{
			char	c = *CRemotePtr<char>(hProcess,pvAddr);
			if (c>=32 && c<=126)
				psBuffer += sprintf( psBuffer, " = 0x%02X (char=\'%c\')",c,c);
			else
				psBuffer += sprintf( psBuffer, " = 0x%02X (char)",c);
		}
		if (qwLength == 4)
		{
			CRemotePtr<PSTR*>			pStrAddr(hProcess,pvAddr);
			CRemotePtr<char[32]>		pStr(hProcess,*pStrAddr);
			
			if (IsBadRemoteStringPtrA(hProcess,(PCSTR)*pStrAddr,32))
				psBuffer += sprintf( psBuffer, " = %X", (PDWORD)*pStrAddr );
			else
				psBuffer += sprintf(psBuffer, " = \"%.31s\"", *pStr );			
		}
		break;

	case btWChar:
		if (qwLength == 4)
		{
			CRemotePtr<PWSTR*>			pStrAddr(hProcess,pvAddr);
			CRemotePtr<WCHAR[32]>		pStr(hProcess,*pStrAddr);
			
			if (IsBadRemoteStringPtrW(hProcess,(PCWSTR)*pStrAddr,32))
				psBuffer += sprintf( psBuffer, " = %X", (PDWORD)*pStrAddr );
			else
				psBuffer += sprintf(psBuffer, " = \"%.31S\"", *pStr );			
		}
		break;

	case btBSTR:
		if (qwLength == 4)
		{
			CRemotePtr<BSTR*>			pStrAddr(hProcess,pvAddr);
			CRemotePtr<WORD>			pStrLen(hProcess,(*pStrAddr)-1);
			CRemotePtr<WCHAR[32]>		pStr(hProcess,*pStrAddr);
			WORD						wLen = (!pStrLen) ? 0 : *pStrLen;

			if (wLen && !IsBadRemoteStringPtrW(hProcess, (PCWSTR)*pStrAddr, wLen))
			{
				PWSTR	ws = (PWSTR)_alloca((wLen+1)*sizeof(WCHAR));
				wcsncpy(ws,*pStr,wLen); *(ws+wLen) = L'\0';
				psBuffer += sprintf(psBuffer, " = \"%.31S\"", ws );
			}
			else
				psBuffer += sprintf( psBuffer, " = %p", *pStrAddr );
		}
		break;

	default:
		return psBuffer;
	}
	return psBuffer;
}



BasicType GetBasicType(DWORD dwTypeIndex, DWORD64 modBase, HANDLE hProcess)
{
	BasicType	btType;
	DWORD		dwTypeID;

	if (SymGetTypeInfo( hProcess, modBase, dwTypeIndex, TI_GET_BASETYPE, &btType))
		return btType;

	// Get the real "TypeId" of the child.  We need this for the SymGetTypeInfo( TI_GET_TYPEID ) call below.
	if (SymGetTypeInfo( hProcess, modBase, dwTypeIndex, TI_GET_TYPEID, &dwTypeID))
	{
		if (SymGetTypeInfo( hProcess, modBase, dwTypeID, TI_GET_BASETYPE, &btType))
			return btType;
	}

	return btNoType;
}



//////////////////////////////////////////////////////////////////////////////
// If it's a user defined type (UDT), recurse through its members until we're
// at fundamental types.  When he hit fundamental types, return
// bHandled = false, so that FormatSymbolValue() will format them.
//////////////////////////////////////////////////////////////////////////////
PSTR DumpTypeIndex(PSTR			psBuffer,
				   DWORD64		modBase,
				   DWORD		dwTypeIndex,
				   unsigned		nestingLevel,
				   DWORD_PTR	offset,
				   bool			&bHandled,
				   HANDLE		hProcess)
{
	PWSTR	wsTypeName		= NULL;
	DWORD	dwChildrenCount = 0;
	PSTR	psBuff			= psBuffer;

	bHandled = false;

	//Get the name of the symbol.  This will either be a Type name (if a UDT),
	//or the structure member name.
	if ( SymGetTypeInfo( hProcess, modBase, dwTypeIndex, TI_GET_SYMNAME, &wsTypeName))
	{
		psBuff += sprintf( psBuff, " %ls", wsTypeName );
		LocalFree(wsTypeName);
	}

	// Determine how many children this type has.
	SymGetTypeInfo( hProcess, modBase, dwTypeIndex, TI_GET_CHILDRENCOUNT,&dwChildrenCount);

	if (!dwChildrenCount)     // If no children, we're done
		return psBuff;

	// Prepare to get an array of "TypeIds", representing each of the children.
	// SymGetTypeInfo(TI_FINDCHILDREN) expects more memory than just a
	// TI_FINDCHILDREN_PARAMS struct has.  Use derivation to accomplish this.
	struct FINDCHILDREN : TI_FINDCHILDREN_PARAMS
	{
		ULONG   MoreChildIds[1024];
		FINDCHILDREN(){Count = sizeof(MoreChildIds) / sizeof(MoreChildIds[0]);}
	} children;

	children.Count = dwChildrenCount;
	children.Start = 0;

	// Get the array of TypeIds, one for each child type
	if (!SymGetTypeInfo( hProcess, modBase, dwTypeIndex, TI_FINDCHILDREN,&children))
		return psBuff;

	// Append a line feed
	psBuff += sprintf( psBuff, "\r\n" );

	// Iterate through each of the children
	for (DWORD i = 0; i < dwChildrenCount; i++ )
	{
		bool	bIntHandled;

		// Add appropriate indentation level (since this routine is recursive)
		for (DWORD j = 0; j <= nestingLevel+1; j++ )
			psBuff += sprintf( psBuff, "    " );

		// Recurse for each of the child types
		psBuff = DumpTypeIndex( psBuff, modBase, children.ChildId[i], nestingLevel+1, offset, bIntHandled, hProcess);

		// If the child wasn't a UDT, format it appropriately
		if (!bIntHandled)
		{
			DWORD		dwMemberOffset	= 0;
			DWORD		dwTypeID		= 0;
			ULONG64		length			= 0;
			BasicType	btType			= btNoType;

			// Get the offset of the child member, relative to its parent
			SymGetTypeInfo( hProcess, modBase, children.ChildId[i],
				TI_GET_OFFSET, &dwMemberOffset );

			// Get the real "TypeId" of the child.  We need this for the
			// SymGetTypeInfo( TI_GET_TYPEID ) call below.
			SymGetTypeInfo( hProcess, modBase, children.ChildId[i],
				TI_GET_TYPEID, &dwTypeID);

			// Get the size of the child member
			SymGetTypeInfo( hProcess, modBase, dwTypeID, TI_GET_LENGTH,&length);

			// Calculate the address of the member
			btType = GetBasicType( children.ChildId[i], modBase, hProcess );
			psBuff = FormatOutputValue(psBuff, btType, length, (PVOID)(offset + dwMemberOffset), hProcess);
			psBuff += sprintf( psBuff, "\r\n" );
		}
	}

	bHandled = true;
	return psBuff;
}



BOOL FormatSymbolValue(PSTR			psBuffer,
					   PSYMBOL_INFO pSym,
					   STACKFRAME*	pSF,
					   HANDLE		hProcess
					   )
{
	PSTR		psBuff		= psBuffer;
	DWORD_PTR	pVariable	= 0;		// Will point to the variable's data in memory
	bool		bHandled	= false;

	// Indicate if the variable is a local or parameter
	if ( pSym->Flags & IMAGEHLP_SYMBOL_INFO_PARAMETER )
		psBuff += sprintf( psBuff, "Parameter " );
	else if ( pSym->Flags & IMAGEHLP_SYMBOL_INFO_LOCAL )
		psBuff += sprintf( psBuff, "Local " );

	// If it's a function, don't do anything.
	if ( pSym->Tag == SymTagFunction)   //SymTagFunction from CVCONST.H from the DIA SDK
		return FALSE;

	// Emit the variable name
	psBuff += sprintf( psBuff, "\'%s\'", pSym->Name );


	if ( pSym->Flags & IMAGEHLP_SYMBOL_INFO_REGRELATIVE )
	{
		// if ( pSym->Register == 8 )   // EBP is the value 8 (in DBGHELP 5.1) This may change!!!
		{
			pVariable = pSF->AddrFrame.Offset;
			pVariable += (DWORD_PTR)pSym->Address;
		}
		// else
		//  return FALSE;
	}
	else if ( pSym->Flags & IMAGEHLP_SYMBOL_INFO_REGISTER )
		return FALSE;   // Don't try to report register variable
	else 
		pVariable = (DWORD_PTR)pSym->Address;   // It must be a global variable

	// Determine if the variable is a user defined type (UDT).  IF so, bHandled will return true.
	psBuff = DumpTypeIndex(psBuff, pSym->ModBase, pSym->TypeIndex, 0, pVariable, bHandled, hProcess);

	if ( !bHandled )
	{
		// The symbol wasn't a UDT, so do basic, stupid formatting of the
		// variable.  Based on the size, we're assuming it's a char, WORD, or DWORD.
		psBuff = FormatOutputValue(psBuff,
			GetBasicType( pSym->TypeIndex, pSym->ModBase, hProcess),
			pSym->Size,
			(PVOID)pVariable,
			hProcess
			);
		psBuff += sprintf( psBuff, "\r\n" );
	}
	return TRUE;
}


typedef struct tagSymEnumCallbackParam
{
	STACKFRAME*	pSF;
	PSTR		psBuffer;
	HANDLE		hProcess;
	tagSymEnumCallbackParam(STACKFRAME*	pSF, PSTR psBuffer, HANDLE hProcess)
		:pSF(pSF), psBuffer(psBuffer), hProcess(hProcess) {}
}ESCB_PARAM, *PESCB_PARAM;

//////////////////////////////////////////////////////////////////////////////
// The function invoked by SymEnumSymbols
//////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK EnumerateSymbolsCallback(PSYMBOL_INFO	pSymInfo,
									   ULONG		SymbolSize,
									   PVOID		UserContext
									   )
{

	__try
	{
		STACKFRAME*	pSF		= PESCB_PARAM(UserContext)->pSF;
		PSTR		psBuff	= PESCB_PARAM(UserContext)->psBuffer;
		HANDLE		hProcess= PESCB_PARAM(UserContext)->hProcess;

		psBuff += sprintf(psBuff, "    ");
		FormatSymbolValue( psBuff, pSymInfo, pSF, hProcess);
		psBuff += strlen(psBuff);

		PESCB_PARAM(UserContext)->psBuffer = psBuff;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		PSTR	psBuff	= PESCB_PARAM(UserContext)->psBuffer;
		psBuff += sprintf(psBuff ,"punting on symbol %s\r\n", pSymInfo->Name );
	}


	return TRUE;
}


PSTR WriteCallStackDetails(PSTR		psBuffer,
						   DWORD	dwPID,
						   HANDLE	hProcess,
						   HANDLE	hThread,
						   PCONTEXT	pContext,
						   bool		bWriteVariables,
						   DWORD	dwMaxDeep)
{
	DWORD		dwMachineType = 0;
	STACKFRAME	sf			  = {0};
	PSTR		pBuff		  = psBuffer;
	DWORD		dwDeep		  = 0;

#ifdef _M_IX86
	// Initialize the STACKFRAME structure for the first call.  This is only
	// necessary for Intel CPUs, and isn't mentioned in the documentation.
	sf.AddrPC.Offset       = pContext->Eip;
//	sf.AddrPC.Segment       = 0xFFFF;
	sf.AddrPC.Mode         = AddrModeFlat;
	sf.AddrStack.Offset    = pContext->Esp;
	sf.AddrStack.Mode      = AddrModeFlat;
	sf.AddrFrame.Offset    = pContext->Ebp;
	sf.AddrFrame.Mode      = AddrModeFlat;

	dwMachineType = IMAGE_FILE_MACHINE_I386;
#endif


	pBuff += sprintf(pBuff,"PDB Call stack:\r\n" );
	pBuff += sprintf(pBuff,"Address   Frame     Function            SourceFile\r\n" );

	while (StackWalk(dwMachineType,hProcess,hThread,
		&sf,pContext,0,
		SymFunctionTableAccess,SymGetModuleBase,0)
		&& sf.AddrFrame.Offset)
	{
		pBuff += sprintf(pBuff, "%08X  %08X  ", sf.AddrPC.Offset, sf.AddrFrame.Offset );
		pBuff = AddressInfo(pBuff,(PVOID)sf.AddrPC.Offset, dwPID, hProcess );
		pBuff += sprintf(pBuff, "\r\n" );


		// Write out the variables, if desired
		if ( bWriteVariables )
		{
			IMAGEHLP_STACK_FRAME	ihStackFrame = {0};

			ihStackFrame.InstructionOffset = sf.AddrPC.Offset;
			SymSetContext( hProcess, &ihStackFrame, 0 );

			// Enumerate the locals/parameters
			if (SymEnumSymbols( hProcess, 0, 0, 
				EnumerateSymbolsCallback,
				&ESCB_PARAM(&sf, pBuff, hProcess)))
			{
				pBuff += strlen(pBuff);
			}
		}

		if (++dwDeep>dwMaxDeep)
		{
			pBuff += sprintf(pBuff,"Callstack too deep\r\n");
			break;
		}
	}
	return pBuff;
}
