//#include "Types.h"

#include <windows.h>
#include <stdio.h>
#include "C:\Program Files\Microsoft Visual Studio .NET 2003\Visual Studio SDKs\DIA SDK\include\CVconst.h"

#include "D:\Projects\TaskManager\Ver.h"
#include "Debug.h"
#include "CallStack.h"

#pragma comment(lib,"Dbghelp.lib")

#pragma warning (push)
#pragma warning (disable : 4290) 

using namespace DebugSys;

//BOOL	Init(DWORD dwAddress, DWORD dwPID, HANDLE hProcess)
BOOL	CSymbolInfo::Init(DWORD dwAddress, DWORD dwPID, HANDLE hProcess)
{
	char				buff[sizeof(this->sName)];
	PIMAGEHLP_SYMBOL	pSym = (PIMAGEHLP_SYMBOL)buff;
	
	pSym->SizeOfStruct	= sizeof(IMAGEHLP_SYMBOL);
	pSym->MaxNameLength	= sizeof(buff) - sizeof(IMAGEHLP_SYMBOL);

	if (!SymGetSymFromAddr(hProcess, dwAddress, &dwOffset,pSym))
	{
		if (GetLastError() != ERROR_MOD_NOT_FOUND)
			return FALSE;

		if (!SymLoadModuleByAddr(dwAddress, dwPID, hProcess))
				return FALSE;

		if (!SymGetSymFromAddr(hProcess, dwAddress, &dwOffset, pSym))
				return FALSE;
	}

	this->dwAddr	= dwAddress;
	this->dwSize	= pSym->Size;
	strcpy(this->sName,pSym->Name);
	return TRUE;
}


//BOOL	Init(DWORD dwAddress,  DWORD dwPID, HANDLE hProcess)
BOOL	CLineInfo::Init(DWORD dwAddress,  DWORD dwPID, HANDLE hProcess)
{
	char				buff[sizeof(this->sFile)];
	PIMAGEHLP_LINE		pLine		= (PIMAGEHLP_LINE) buff;
	
	pLine->SizeOfStruct	= sizeof(IMAGEHLP_LINE);
	
	if (!SymGetLineFromAddr(hProcess, (DWORD)dwAddress ,&dwOffset,pLine))
	{
		if (GetLastError() != ERROR_MOD_NOT_FOUND)
			return FALSE;

		if (!SymLoadModuleByAddr(dwAddress,dwPID,hProcess))
			return FALSE;
		
		if (!SymGetLineFromAddr(hProcess, (DWORD)dwAddress ,&dwOffset,pLine))
			return FALSE;
	}

	this->dwAddr	= dwAddress;
	this->dwLine	= pLine->LineNumber;
	strcpy(this->sFile,pLine->FileName);
	return TRUE;
};


//BOOL	Init(DWORD dwAddress, DWORD dwPID, HANDLE hProcess))
BOOL	CModuleInfo::Init(DWORD dwAddress, DWORD dwPID, HANDLE hProcess)
{
	IMAGEHLP_MODULE	im;

	im.SizeOfStruct = sizeof(im);
	if (!SymGetModuleInfo(hProcess, dwAddress, &im))
	{
		if (GetLastError() != ERROR_MOD_NOT_FOUND)
			return FALSE;

		if (!SymLoadModuleByAddr(dwAddress, dwPID, hProcess))
			return FALSE;
		
		if (!SymGetModuleInfo(hProcess, dwAddress, &im))
			return FALSE;
	}

	m_dwAddr		= dwAddress;
	m_dwImageBase	= im.BaseOfImage;
	m_dwImageSize	= im.ImageSize;
	strcpy(m_sModuleName,	im.ModuleName);
	strcpy(m_sImageName,	im.ImageName);
	
	GetModuleFileName((HMODULE)m_dwImageBase, m_sFileName,sizeof(m_sFileName));
	return TRUE;
}

#pragma warning (pop)


MODULEENTRY32 DebugSys::GetModuleInfoByAddress(PVOID			pvAddress,
											   DWORD			dwPID)
{
	MODULEENTRY32	meZero	= { 0 };
	MODULEENTRY32	me		= { sizeof(MODULEENTRY32) };
	HANDLE			hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwPID);
	
	if (!hSnapShot)
		return meZero;

	__try
	{
		if (!Module32First(hSnapShot,&me))
			return meZero;

		do{
			if ((me.modBaseAddr<= pvAddress)
				&& (me.modBaseAddr+me.modBaseSize > pvAddress))
				return me;
		}while(Module32Next(hSnapShot,&me));
	}
	__finally
	{
		CloseHandle(hSnapShot);
	}
	return meZero;
}

BOOL	DebugSys::SymLoadModuleByAddr(DWORD		dwAddress,
									  DWORD		dwPID,
									  HANDLE	hProcess)
{
	MODULEENTRY32	me		= GetModuleInfoByAddress((PVOID)dwAddress,dwPID);
	
	if (!me.dwSize)
		return FALSE;
	
	if (!SymLoadModule(	hProcess,
						me.hModule,
						me.szExePath,
						me.szModule,
						(DWORD)me.modBaseAddr,
						me.modBaseSize))
		return FALSE;
	return TRUE;
}



PCSTR	DebugSys::ExceptionCodeToString(DWORD dwExceptionCode)
{
	//       case,   
	#define EH_CASE( x )		\
	case x :					\
		return #x;				\

	switch (dwExceptionCode)
	{
	EH_CASE( EXCEPTION_GUARD_PAGE				)	//0x80000001L
	EH_CASE( EXCEPTION_DATATYPE_MISALIGNMENT	)	//0x80000002L
	EH_CASE( EXCEPTION_BREAKPOINT				)	//0x80000003L
	EH_CASE( EXCEPTION_SINGLE_STEP				)	//0x80000004L

	EH_CASE( DBG_TERMINATE_THREAD				)	//0x40010003L
	EH_CASE( DBG_TERMINATE_PROCESS				)	//0x40010004L
	EH_CASE( DBG_CONTROL_C						)	//0x40010005L
	EH_CASE( DBG_CONTROL_BREAK					)	//0x40010008L

	EH_CASE( EXCEPTION_ACCESS_VIOLATION			)	//0xC0000005L
	EH_CASE( EXCEPTION_IN_PAGE_ERROR			)	//0xC0000006L
	EH_CASE( EXCEPTION_INVALID_HANDLE			)	//0xC0000008L
	
	EH_CASE( STATUS_NO_MEMORY					)	//0xC0000017L
	
	EH_CASE( EXCEPTION_ILLEGAL_INSTRUCTION		)	//0xC000001DL
	
	EH_CASE( EXCEPTION_NONCONTINUABLE_EXCEPTION	)	//0xC0000025L
	EH_CASE( EXCEPTION_INVALID_DISPOSITION		)	//0xC0000026L
	EH_CASE( EXCEPTION_ARRAY_BOUNDS_EXCEEDED	)	//0xC000008CL
	EH_CASE( EXCEPTION_FLT_DENORMAL_OPERAND		)	//0xC000008DL
	EH_CASE( EXCEPTION_FLT_DIVIDE_BY_ZERO		)	//0xC000008EL
	EH_CASE( EXCEPTION_FLT_INEXACT_RESULT		)	//0xC000008FL
	EH_CASE( EXCEPTION_FLT_INVALID_OPERATION	)	//0xC0000090L
	EH_CASE( EXCEPTION_FLT_OVERFLOW				)	//0xC0000091L
	EH_CASE( EXCEPTION_FLT_STACK_CHECK			)	//0xC0000092L
	EH_CASE( EXCEPTION_FLT_UNDERFLOW			)	//0xC0000093L
	EH_CASE( EXCEPTION_INT_DIVIDE_BY_ZERO		)	//0xC0000094L
	EH_CASE( EXCEPTION_INT_OVERFLOW				)	//0xC0000095L
	EH_CASE( EXCEPTION_PRIV_INSTRUCTION			)	//0xC0000096L
	EH_CASE( EXCEPTION_STACK_OVERFLOW			)	//0xC00000FDL
	EH_CASE( CONTROL_C_EXIT						)	//0xC000013AL
	EH_CASE( STATUS_FLOAT_MULTIPLE_FAULTS		)	//0xC00002B4L
	EH_CASE( STATUS_FLOAT_MULTIPLE_TRAPS		)	//0xC00002B5L
	EH_CASE( STATUS_REG_NAT_CONSUMPTION			)	//0xC00002C9L

	case 0xc0000142:
		return "a DLL Initialization Failed";

	case 0xe06d7363:
		return "a Microsoft C++ Exception";
	
	case 0x0eedfae6:
	case 0x0eedfade:
	case 0x0eefface:
		return "C-Builder C++ Exception";

	default:
		{
			static char sException[255];
			FormatMessageA( FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_FROM_HMODULE | FORMAT_MESSAGE_MAX_WIDTH_MASK,
							GetModuleHandleA("NTDLL.DLL" ),
							dwExceptionCode,
							MAKELANGID(LANG_ENGLISH,SUBLANG_DEFAULT),					//LANG ID
							sException, sizeof( sException ),
							0 );

			return sException;
		}
	}
#undef EH_CASE
}

PSTR DebugSys::DumpBasicRegisters(PSTR pBuffer, PCONTEXT lpEC)
{
	return pBuffer + 
	sprintf(pBuffer, "  EAX=%08X EBX=%08X ECX=%08X EDX=%08X \r\n"
					 "  DS:ESI=%04X:%08X ES:EDI=%04X:%08X \r\n"
					 "  CS:EIP=%04X:%08X SS:ESP=%04X:%08X \r\n",
					 lpEC->Eax,lpEC->Ebx,lpEC->Ecx,lpEC->Edx,
					 lpEC->SegDs,lpEC->Esi, lpEC->SegEs,lpEC->Edi,
					 lpEC->SegCs,lpEC->Eip, lpEC->SegSs,lpEC->Esp);
}

template <class T>
PSTR DebugSys::DumpStruct(PSTR pStr,PVOID pDump,int iSize)
{
	static char	sHexNum[] = "0123456789ABCDEF";	
	PSTR		pS = pStr;

	if (!sizeof(T))
		return pStr;

	for(int i=0; i<sizeof(T) ; i++)
	{
		BYTE	b = *((PBYTE)pDump+i);
		
		pS = pStr+(sizeof(T)-i-1)*2;
		
		if (i<iSize)
		{
			*pS		= sHexNum[ b >> 4  ];
			*(pS+1)	= sHexNum[ b & 0x0F];
		}
		else
		{
			*pS		= '?';
			*(pS+1)	= '?';
		}	
	}
	
	pS = pStr+sizeof(T)*2;
	*pS = 0;
	return pS;
}

template <class T>
PSTR DebugSys::WriteHexDumpRow(PSTR pStr,PVOID pDump, int iSize)
{
	PSTR	pS = pStr;
	*pS = 0;
	
	//todo:address
	for(int i=0; i<16; i+= sizeof(T))
	{
		pS = DumpStruct<T>(pS, PBYTE(pDump)+i, iSize-i);
		*pS++ = ' ';
	}

	*pS = 0;
	return pS;
}


template <class T>
PSTR DebugSys::WriteTextDumpRow(PSTR pStr,PVOID pDump, int iSize)
{
	PSTR	pS = pStr;
	*pS = 0;
	
	for(int i=0; i<16; i++)
	{
		if (i<iSize)
		{
			char	c = *(PBYTE(pDump)+i);
			*pS = (c<32 || c>127) ? '.' : c;
		}
		else
			*pS = '?';
		++pS;
	}

	*pS = 0;
	return pS;
}

template <class T>
PSTR DebugSys::WriteMemoryDump(PSTR pStr,PVOID pDump, int iSize, DWORD dwFlags)
{
	PBYTE	pD = (PBYTE)pDump;
	PSTR	pS = pStr;

	for(int i=0; i<iSize; i+=16, pD+=16)
	{
		if (dwFlags & MEMDUMP_ADDRESS)
			pS += sprintf(pS,"0x%p ",pD);
		
		pS = WriteHexDumpRow<T>(pS,pD,iSize-i);
		
		if (dwFlags & MEMDUMP_TEXT)
		{
			pS = WriteTextDumpRow<T>(pS,pD,iSize-i);
		}
		pS += sprintf(pS,"\r\n");
	}
	return pS;
}

PSTR DebugSys::GetModuleList(PSTR pStr, DWORD dwPID)
{
	PSTR	pS		  = pStr;
	HANDLE	hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE,dwPID);

	if (hSnapShot)
	{
		MODULEENTRY32	me;
		me.dwSize = sizeof(me);

		if (Module32First(hSnapShot,&me))
		{
			pS += sprintf(pS,"Module list:\r\n");

			do {
				CModuleVersion	mv(me.szExePath);

				pS += sprintf(pS,"  %08X   ",me.modBaseAddr);
				
				FillMemory(pS,strlen("XX.XXXX.XXXX.XXXX    "),' ');
				if (mv)
				{
					char	sVer[64];
					sprintf(sVer,"%i.%i.%i.%i",
						HIWORD(HIDWORD(mv.ProductVersion)),
						LOWORD(HIDWORD(mv.ProductVersion)),
						HIWORD(LODWORD(mv.ProductVersion)),
						LOWORD(LODWORD(mv.ProductVersion)));
					strncpy(pS,sVer,strlen(sVer));
				}
				pS += strlen(pS);
				pS += sprintf(pS,"%s\r\n",me.szExePath);

			} while(Module32Next(hSnapShot,&me));
		}
		CloseHandle(hSnapShot);
		
		pS += sprintf(pS,"\r\n");
	}
	return pS;
}

PSTR DebugSys::AddressInfo(PSTR pBuff, PVOID pvAddr, DWORD dwPID, HANDLE hProcess)
{
	PSTR					pStr = pBuff;
	DebugSys::CSymbolInfo	si(pvAddr,dwPID,hProcess);
	DebugSys::CLineInfo		li(pvAddr,dwPID,hProcess);
	DebugSys::CModuleInfo	mi(pvAddr,dwPID,hProcess);

	*pBuff = 0;

	if(si)
		pStr += sprintf(pStr,"%s+%i ",si.Name,si.Offset);

	if(li)
		pStr += sprintf(pStr,"File(%s) Line %i + %i ",li.File,li.LineNumber,li.Offset);

	if(mi)
	{
		PCIMAGE_SECTION_HEADER	pSection = mi.GetSectionByAddress(pvAddr);
		if (pSection)
		{
			pStr += sprintf(pStr,"%s+0x%p ",
				pSection->Name, 
				(DWORD)(pvAddr) - (DWORD)mi.ImageBase - (DWORD)pSection->VirtualAddress);
		}
		pStr += sprintf(pStr,"module %s ",mi.ModuleName);
	}
	return pStr;
}


__declspec( naked ) PVOID __cdecl GetEIP()
{
	_asm mov eax,[esp]
	_asm ret
}

__declspec( naked ) PVOID __cdecl GetESP()
{
	_asm lea eax,[esp+4]
	_asm ret
}

__declspec( naked ) PVOID __cdecl GetEBP()
{
	_asm mov eax,ebp
	_asm ret
}



