#ifndef _EDITSECURITY_H_
#define _EDITSECURITY_H_

#define NUM_PROCESS_RIGHTS      19
#define NUM_THREAD_RIGHTS       16

#include <aclui.h>

struct AccessRight {
    WCHAR Name[32];
    ACCESS_MASK AccessMask;
};

class TObjectSecurityInfo: public ISecurityInformation {
    ULONG m_cRef;
    HANDLE hObject;
    PSECURITY_DESCRIPTOR psd;
    PSI_ACCESS psi;
    int NumAccessRights;
    WCHAR ObjectName[MAX_PATH];
    AccessRight *AccessRights;
public:
    // 
    TObjectSecurityInfo(HANDLE hObject, LPTSTR ObjectName,
        AccessRight *ar, int NumAccessRights);
    ~TObjectSecurityInfo();

    //  IUnknown
	STDMETHODIMP QueryInterface(REFIID riid, LPVOID FAR *ppv);
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();

    //  ISecurityInformation
    STDMETHODIMP GetObjectInformation(
        PSI_OBJECT_INFO pObjectInfo);
    STDMETHODIMP GetSecurity(
        SECURITY_INFORMATION RequestedInformation,
        PSECURITY_DESCRIPTOR *ppSecurityDescriptor,
        BOOL fDefault);
    STDMETHODIMP SetSecurity(
        SECURITY_INFORMATION SecurityInformation,
        PSECURITY_DESCRIPTOR pSecurityDescriptor);
    STDMETHODIMP GetAccessRights(
        const GUID *pguidObjectType,
        DWORD dwFlags,
        PSI_ACCESS *ppAccess,
        ULONG *pcAccesses,
        ULONG *piDefaultAccess);
    STDMETHODIMP MapGeneric(
        const GUID *pguidObjectType,
        UCHAR *pAceFlags,
        ACCESS_MASK *pMask);
    STDMETHODIMP GetInheritTypes(
        PSI_INHERIT_TYPE *ppInheritTypes,
        ULONG *pcInheritTypes);
    STDMETHODIMP PropertySheetPageCallback(
        HWND hwnd,
        UINT uMsg,
        SI_PAGE_TYPE uPage);
};

BOOL EditProcessSecurity(HWND hWnd, DWORD ProcessId, LPTSTR ProcessName);
BOOL EditThreadSecurity(HWND hWnd, DWORD ThreadId);

#endif
