//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FHandles.h"
#include "Main.h"
#include "TSaveTableDlg.h"
#include "Utils.h"
#include "PerfInfo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Placemnt"
#pragma resource "*.dfm"
TFrmHandles *FrmHandles;
//---------------------------------------------------------------------------
__fastcall TFrmHandles::TFrmHandles(TComponent* Owner)
	: TForm(Owner)
{
    LastCol = 0;
    OrderBy = 1;
}
//---------------------------------------------------------------------------
void __fastcall TFrmHandles::SetProcess(TMyProcess *prc)
{
    Process = prc;
    if (!prc)
    {
        LVHandles->Items->Clear();
        Caption = "";
    }
    else
    {
    	AnsiString str;
        str.printf(
        	"  \"%s\" (PID=%lu)",
        	Process->ProcessName,
            Process->pid);
	    Caption = str;
    }
    StatusBar->SimpleText = "";
    RefreshList();
}
//---------------------------------------------------------------------------
void __fastcall TFrmHandles::RefreshList()
{
	PMyHandleInfo phi = NULL;
    DWORD dwHandleCount = 0, i;
    SYSTEMTIME st;
    TListItem* li;
    AnsiString str;

    LVHandles->Items->Clear();
//    LVHandles->Enabled = Process->pid;
    if (!Process) return;

	if (!GetHandleInfo(Process->pid, &phi, &dwHandleCount))
    {
    	delete phi;
        return;
    }

    StatusBar->SimpleText = AnsiString(" : ") + dwHandleCount;

    for (i = 0; i < dwHandleCount; i++)
    {
	    li = LVHandles->Items->Add();
        li->ImageIndex = -1;
        str.printf("0x%p", phi[i].Handle);
    	li->Caption = str;
        li->SubItems->Add(phi[i].TypeName);
        SysFreeString(phi[i].TypeName);
        str.printf("0x%p", phi[i].GrantedAccess);
        li->SubItems->Add(str);
        if (phi[i].ObjectName)
        {
        	li->SubItems->Add(phi[i].ObjectName);
            SysFreeString(phi[i].ObjectName);
        }
        else
        {
        	li->SubItems->Add("");
        }
        str.printf("0x%p", phi[i].Flags);
        li->SubItems->Add(str);
        str = "";
        str.printf("0x%p", phi[i].Object);
        li->SubItems->Add(str);
        li->SubItems->Add(phi[i].PointerCount);
        li->SubItems->Add(phi[i].HandleCount);
        if (phi[i].PagedPoolUsage)
        {
        	li->SubItems->Add(phi[i].PagedPoolUsage);
        }
        else
        {
        	li->SubItems->Add("Default");
        }
        if (phi[i].NonPagedPoolUsage)
        {
	        li->SubItems->Add(phi[i].NonPagedPoolUsage);
        }
        else
        {
        	li->SubItems->Add("Default");
        }
        li->SubItems->Add(phi[i].ObjectTypeNumber);
    }

   	delete phi;
}

/*
    ULONG HandleCount;
    ULONG PeakHandleCount;
    ULONG PointerCount;
    ULONG ObjectCount;
    ULONG PeakObjectCount;
    POOL_TYPE PoolType;
    ULONG PagedPoolUsage;
    ULONG NonPagedPoolUsage;
	ULONG InvalidAttributes;
	GENERIC_MAPPING GenericMapping;
    ULONG ValidAccess;
    BOOLEAN MaintainHandleDatabase;
*/
void __fastcall TFrmHandles::RefreshBtnClick(TObject *Sender)
{
	RefreshList();	
}
//---------------------------------------------------------------------------
void __fastcall TFrmHandles::FormResize(TObject *Sender)
{
    ToolBar->Width = ControlBar->ClientWidth;
}
//---------------------------------------------------------------------------
void __fastcall TFrmHandles::StayOnTopBtnClick(TObject *Sender)
{
    SetStayOnTop(Handle, StayOnTopBtn->Down);
}
//---------------------------------------------------------------------------
void __fastcall TFrmHandles::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    MainForm->iHandles->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TFrmHandles::SaveBtnClick(TObject *Sender)
{
    SaveTableDlg->Save(LVHandles);
}
//---------------------------------------------------------------------------
void __fastcall TFrmHandles::LVHandlesKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if (Key == VK_F5) RefreshList();
    else if (Key == 'S' && Shift.Contains(ssCtrl))
        SaveBtnClick(NULL);
}
//---------------------------------------------------------------------------
int __stdcall CustomSortProc5(long Item1, long Item2, long ParamSort)
{
    int res, n = (ParamSort & 0xFFFF), OrderBy = ParamSort >> 16;
    TListItem *li1 = (TListItem *)Item1, *li2 = (TListItem *)Item2;

    if (!n)
        res = MyCompareStr(li1->Caption.c_str(),
            li2->Caption.c_str(), true);
    else
        res = MyCompareStr(li1->SubItems->Strings[n - 1].c_str(),
            li2->SubItems->Strings[n - 1].c_str(), n == 1 || n == 3 || n == 12);

    return res * OrderBy;
}
//---------------------------------------------------------------------------
void __fastcall TFrmHandles::SortColumn(int Col, int OrderBy)
{
    int i = 0, k = LVHandles->Columns->Count;
    LVCOLUMN col;
    for (; i < k; i++)
    {
        col.mask = LVCF_FMT;
        col.fmt = 0;
        if (i == Col)
        {
            col.fmt |=
                LVCFMT_BITMAP_ON_RIGHT |
                LVCFMT_COL_HAS_IMAGES |
                LVCFMT_IMAGE;
            col.mask |= LVCF_IMAGE;
            col.iImage = OrderBy > 0 ? 3 : 4;
        }
        ListView_SetColumn(LVHandles->Handle, i, &col);
    }
    LVHandles->CustomSort(CustomSortProc5, Col | (OrderBy << 16));
}
//---------------------------------------------------------------------------
void __fastcall TFrmHandles::LVHandlesColumnClick(TObject *Sender,
      TListColumn *Column)
{
    int index = Column->Index;
    OrderBy = index == LastCol ? OrderBy * -1 : 1;
    SortColumn(index, OrderBy);
    LastCol = index;
}
//---------------------------------------------------------------------------

