//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <tlhelp32.h>
#include <ExtCtrls.hpp>
#include <Registry.hpp>
#include "MyProcess.h"
#include <ImgList.hpp>
#include <Graphics.hpp>
#include "Placemnt.hpp"
#include <Chart.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <Series.hpp>
#include "CustomProgressBar.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TStatusBar *StatusBar;
    TMainMenu *MainMenu1;
    TMenuItem *iFile;
    TMenuItem *iExit;
    TMenuItem *iView;
    TMenuItem *iRefresh;
    TMenuItem *iSeparator1;
    TMenuItem *iSelColumns;
    TTimer *Timer;
    TPopupMenu *ProcessPopup;
    TMenuItem *iKillProcess;
    TMenuItem *iPriority;
    TMenuItem *iRealTime;
    TMenuItem *iHigh;
    TMenuItem *iAboveNormal;
    TMenuItem *iNormal;
    TMenuItem *iBelowNormal;
    TMenuItem *iLow;
    TMenuItem *iSetPrivileges;
    TMenuItem *N3;
    TMenuItem *N2;
    TMenuItem *iRun;
    TMenuItem *iSettings;
    TMenuItem *iStayOnTop;
    TMenuItem *iRefreshSpeed;
    TMenuItem *iHighSpeed;
    TMenuItem *iNormalSpeed;
    TMenuItem *iLowSpeed;
    TMenuItem *iPaused;
    TImageList *ImageList;
    TMenuItem *iKillProcessTree;
    TMenuItem *N1;
    TMenuItem *iModsList;
    TMenuItem *iSaveInfo;
    TMenuItem *N4;
    TMenuItem *iVerInfo;
    TMenuItem *iStartupInfo;
    TPageControl *PageControl;
    TTabSheet *ProcessesTab;
    TListView *ProcessList;
    TButton *TerminateBtn;
    TTabSheet *ProcessTreeTab;
    TButton *TerminateBtn2;
    TTreeView *ProcessTree;
    TButton *TerminateProcessTreeBtn;
    TTabSheet *SysInfoTab;
    TListView *SysInfoList;
    TMenuItem *iMemInfo;
    TMenuItem *N5;
    TMenuItem *iViewMem;
    TMenuItem *iSecurity;
    TMenuItem *iThreadsList;
    TMenuItem *iResetWorkingSetSize;
    TMenuItem *iChangeWorkingSet;
    TMenuItem *N6;
    TMenuItem *iProperties;
	TMenuItem *N7;
	TMenuItem *iModsList2;
	TMenuItem *iThreadsList2;
	TMenuItem *iMemInfo2;
	TMenuItem *iKillSamePrc;
	TMenuItem *iModSearch;
	TMenuItem *N8;
	TMenuItem *iSnapshot;
	TMenuItem *iHelp;
	TMenuItem *iAbout;
	TMenuItem *iViewSrc;
	TFormStorage *FormStorage1;
	TMenuItem *iHide;
	TPopupMenu *PopupMenu1;
	TMenuItem *iClose;
	TMenuItem *N9;
	TMenuItem *iStayOnTop2;
	TMenuItem *iRestore;
	TTabSheet *PerfTab;
	TGroupBox *GBCPUUse;
	TPanel *PCPUUse;
	TPaintBox *PBCPUUse;
	TGroupBox *GBMemUse;
	TPanel *PMemUse;
	TPaintBox *PBMemUse;
	TCustomProgressBar *CustomProgressBar1;
	TCustomProgressBar *CustomProgressBar2;
	TTabSheet *AdvancedTab;
	TGroupBox *GBTotal;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *LDescriptors;
	TLabel *LThreads;
	TLabel *LProcesses;
	TGroupBox *GBPhysMem;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TLabel *LTotalPM;
	TLabel *LAvailPM;
	TLabel *LCachePM;
	TGroupBox *GroupBox1;
	TGroupBox *GroupBox2;
	TListView *LVAdvPerf;
	TCheckBox *CBSelProcesses;
	TLabel *Label7;
	TLabel *LCommitTotal;
	TLabel *LCommitLimit;
	TLabel *LCommitPeak;
	TLabel *Label11;
	TLabel *Label12;
	TLabel *Label8;
	TLabel *LKernelTotal;
	TLabel *LKernelPaged;
	TLabel *LKernelNP;
	TLabel *Label14;
	TLabel *Label15;
	TTabSheet *TabSheet5;
	TPageControl *PCCPUInfo;
	TTabSheet *TabSheet1;
	TLabel *Label9;
	TLabel *Label10;
	TLabel *Label13;
	TLabel *Label16;
	TLabel *Label17;
	TLabel *Label18;
	TLabel *LVendor;
	TLabel *LProcType;
	TLabel *LFamily;
	TLabel *LModel;
	TLabel *LStepping;
	TLabel *LSerialNo;
	TTabSheet *TabSheet2;
	TListBox *LBFeatures;
	TTabSheet *TabSheet3;
	TListBox *LBCache;
	TTabSheet *TabSheet4;
	TLabel *Label19;
	TLabel *Label20;
	TLabel *Label21;
	TLabel *Label22;
	TLabel *LMaxPARange;
	TLabel *LMaxVARange;
	TListBox *LBPowerFeatures;
	TMenuItem *iHandleList;
	TMenuItem *iHandles;
    void __fastcall iExitClick(TObject *Sender);
    void __fastcall iRefreshClick(TObject *Sender);
    void __fastcall TerminateBtnClick(TObject *Sender);
    void __fastcall iSelColumnsClick(TObject *Sender);
    void __fastcall TimerTimer(TObject *Sender);
    void __fastcall ProcessListColumnClick(TObject *Sender,
          TListColumn *Column);
    void __fastcall PriorityClick(TObject *Sender);
    void __fastcall iSetPrivilegesClick(TObject *Sender);
    void __fastcall iRunClick(TObject *Sender);
    void __fastcall iStayOnTopClick(TObject *Sender);
    void __fastcall iRefreshSpeedClick(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall iKillProcessTreeClick(TObject *Sender);
    void __fastcall iModsListClick(TObject *Sender);
    void __fastcall ProcessListSelectItem(TObject *Sender, TListItem *Item,
          bool Selected);
    void __fastcall iSaveInfoClick(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall iVerInfoClick(TObject *Sender);
    void __fastcall iStartupInfoClick(TObject *Sender);
    void __fastcall TerminateProcessTreeBtnClick(TObject *Sender);
    void __fastcall ProcessTreeChange(TObject *Sender, TTreeNode *Node);
    void __fastcall ProcessTreeKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall ProcessTreeMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall iMemInfoClick(TObject *Sender);
    void __fastcall iViewMemClick(TObject *Sender);
    void __fastcall ProcessListDeletion(TObject *Sender, TListItem *Item);
    void __fastcall iSecurityClick(TObject *Sender);
    void __fastcall iThreadsListClick(TObject *Sender);
    void __fastcall iResetWorkingSetSizeClick(TObject *Sender);
    void __fastcall iChangeWorkingSetClick(TObject *Sender);
    void __fastcall iPropertiesClick(TObject *Sender);
	void __fastcall iModsList2Click(TObject *Sender);
	void __fastcall iThreadsList2Click(TObject *Sender);
	void __fastcall iMemInfo2Click(TObject *Sender);
	void __fastcall iKillSamePrcClick(TObject *Sender);
	void __fastcall iModSearchClick(TObject *Sender);
	void __fastcall ProcessPopupPopup(TObject *Sender);
	void __fastcall iSnapshotClick(TObject *Sender);
	void __fastcall iAboutClick(TObject *Sender);
	void __fastcall iViewSrcClick(TObject *Sender);
	void __fastcall ProcessListMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall iRestoreClick(TObject *Sender);
	void __fastcall PBCPUUsePaint(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall PBMemUsePaint(TObject *Sender);
	void __fastcall iHandleListClick(TObject *Sender);
	void __fastcall iHandlesClick(TObject *Sender);
	void __fastcall PerfTabShow(TObject *Sender);
private:	// User declarations
    int NumProcess;
    DWORD Columns;
    double CPUUse;
    TRegIniFile *Reg;
    void __fastcall RefreshProcesses();
    void __fastcall RefreshColumns();
    void __fastcall AddProcessToList(TListItem *li, PSYSTEM_PROCESSES p);
    void __fastcall GetSysInfo();
    void __fastcall AddSysInfoItem(AnsiString param, AnsiString val);
    void __fastcall LoadFormSettings(TForm *frm, AnsiString Name);
    void __fastcall LoadSettings();
    void __fastcall SaveFormSettings(TForm *frm, AnsiString Name);
    void __fastcall SaveSettings();
    bool __fastcall AddProcessToTree(TTreeNode *Root, TMyProcess *p);
    void __fastcall DeleteUnusedNodes(TTreeNode *Root);
    void __fastcall ExpandTree(TTreeNode *Root);
    AnsiString __fastcall GetCaption();
    TMyProcess* __fastcall GetProcess();
	void __fastcall SubClassWndProc(Messages::TMessage &Message);
	void __fastcall UpdatePerfTab();
	void __fastcall UpdateAdvancedTab();
    void __cdecl UpdateAdvPerfInfo(int nCol, const char* pszFmt, ...);
	void __fastcall RepaintGraph(TPaintBox* pBox, double* pData, COLORREF color);
	void __fastcall AddAdvPerfItem(AnsiString name);
	void __fastcall UpdateProcessorInfo();
	void __fastcall UpdateActions();
public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
    __fastcall ~TMainForm();
    friend VOID WINAPI ProcessEnumProc(PSYSTEM_PROCESSES, LPVOID);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
struct ProcEnum {
    bool *Used;
    int k;
    int *NumProcess;
};
//---------------------------------------------------------------------------
#endif

