#include "Procs.h"

#include "Utils.h"

DWORD WINAPI (*SHRunProgramDlgA)(HWND hWnd, HICON hIcon, LPSTR lpDirectory,
    LPSTR lpTitle, LPSTR lpPrompt, DWORD Unknown);
DWORD WINAPI (*SHRunProgramDlgW)(HWND hWnd, HICON hIcon, LPWSTR lpDirectory,
    LPWSTR lpTitle, LPWSTR lpPrompt, DWORD Unknown);
BOOL WINAPI (*_GetProcessWorkingSetSize)(HANDLE, PSIZE_T, PSIZE_T);
BOOL WINAPI (*_SetProcessWorkingSetSize)(HANDLE, SIZE_T, SIZE_T);
BOOL (WINAPI *_EditSecurity)(HWND, LPSECURITYINFO);
BOOL (WINAPI *_GetKernelObjectSecurity)(HANDLE, SECURITY_INFORMATION,
    PSECURITY_DESCRIPTOR, DWORD, LPDWORD);
BOOL (WINAPI *_SetKernelObjectSecurity)(HANDLE,
    SECURITY_INFORMATION, PSECURITY_DESCRIPTOR);

BOOL LoadProcs()
{
    HANDLE hDll = LoadLibrary("shell32.dll");

    if (!hDll) return FALSE;

    *(FARPROC *)&SHRunProgramDlgW =
        GetProcAddress(hDll, (LPSTR)61);
    *(FARPROC *)&SHRunProgramDlgA = *(FARPROC *)&SHRunProgramDlgW;

    if (!SHRunProgramDlgW) return FALSE;

    if (IsWinNT())
    {
        if ((hDll = GetModuleHandle("kernel32.dll")) == NULL)
            return FALSE;

        *(FARPROC *)&_GetProcessWorkingSetSize =
            GetProcAddress(hDll, "GetProcessWorkingSetSize");
        *(FARPROC *)&_SetProcessWorkingSetSize =
            GetProcAddress(hDll, "SetProcessWorkingSetSize");

        if (!_GetProcessWorkingSetSize ||
            !_SetProcessWorkingSetSize) return FALSE;

        if ((hDll = LoadLibrary("aclui.dll")) == NULL)
            return FALSE;

        *(FARPROC *)&_EditSecurity =
            GetProcAddress(hDll, "EditSecurity");

        if (!_EditSecurity ||
            (hDll = GetModuleHandle("advapi32.dll")) == NULL)
            return FALSE;

        *(FARPROC *)&_GetKernelObjectSecurity =
            GetProcAddress(hDll, "GetKernelObjectSecurity");
        *(FARPROC *)&_SetKernelObjectSecurity =
            GetProcAddress(hDll, "SetKernelObjectSecurity");

        if (!_GetKernelObjectSecurity &&
            !_SetKernelObjectSecurity)
            return FALSE;
    }

    return TRUE;
}

