//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SearchThread.h"
#include "Process.h"
#include "TProgressDlg.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TSearchThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall TSearchThread::TSearchThread(bool CreateSuspended,
    HANDLE hProcess, LPBYTE lpStartAddr, LPBYTE Data,
    DWORD cbSize, BOOL IgnoreCase)
    : TThread(CreateSuspended)
{
    ResetEvent(hClosedEvent);
    Found = false;
    this->lpStartAddr = lpStartAddr;
    this->Data = Data;
    this->cbSize = cbSize;
    this->hProcess = hProcess;
    this->IgnoreCase = IgnoreCase;
    TimeToTerminate = FALSE;
}
//---------------------------------------------------------------------------
VOID WINAPI SearchCallback(LPBYTE lpStartAddr, LPBYTE lpAddr, LPVOID lpParam)
{
    TSearchThread *thread = (TSearchThread *)lpParam;
    thread->SearchCallback(lpStartAddr, lpAddr);
}
//---------------------------------------------------------------------------
void __fastcall TSearchThread::Execute()
{
    Found = ProcessSearchData(hProcess, lpStartAddr, Data, cbSize,
        &lpFoundAddr, IgnoreCase, ::SearchCallback, this,
        &TimeToTerminate);
    if (!TimeToTerminate)
    {
        SetEvent(hClosedEvent);
        Synchronize(CloseProgressDlg);
    }
}
//---------------------------------------------------------------------------
void __fastcall TSearchThread::SearchCallback(LPBYTE lpStartAddr, LPBYTE lpAddr)
{
    lpFoundAddr = lpAddr;
    if (ProgressDlg->Visible) Synchronize(SetProgress);
}
//---------------------------------------------------------------------------
void __fastcall TSearchThread::SetProgress()
{
    ProgressDlg->SetProgress(lpStartAddr, lpFoundAddr);
}
//---------------------------------------------------------------------------
void __fastcall TSearchThread::CloseProgressDlg()
{
    ProgressDlg->Close();
}
//---------------------------------------------------------------------------

