//---------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "TEditMemDlg.h"
#include "Utils.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TEditMemDlg *EditMemDlg;
//---------------------------------------------------------------------
__fastcall TEditMemDlg::TEditMemDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
bool __fastcall TEditMemDlg::Execute(HANDLE hProcess,
    DWORD ProcessId, LPVOID Addr)
{
    char buf[64];
    DWORD dwSize;
    wsprintf(buf, "%08X", Addr);
    AddrEdit->Text = buf;
    this->hProcess = hProcess;
    this->ProcessId = ProcessId;
    this->Addr = Addr;
    GetData();
    return ShowModal() == mrOk;
}
//---------------------------------------------------------------------
void __fastcall TEditMemDlg::FormShow(TObject *Sender)
{
    Val->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TEditMemDlg::TypesListChange(TObject *Sender)
{
    GetData();
    RadixList->Enabled = TypesList->ItemIndex < 3;
}
//---------------------------------------------------------------------------
void __fastcall TEditMemDlg::GetData()
{
    unsigned char buf[512];
    Val->Text = "";
    if (!ReadProcessMemory(hProcess, Addr, buf, sizeof(buf), NULL))
        return;
    switch (TypesList->ItemIndex)
    {
        case 0:
            switch (RadixList->ItemIndex)
            {
                case 0: ByteToBinStr(buf[0], buf); break;
                case 1: ByteToOctStr(buf[0], buf); break;
                case 2: wsprintf(buf, "%lu", buf[0]); break;
                case 3: wsprintf(buf, "%02X", buf[0]);
            }
            break;
        case 1:
            switch (RadixList->ItemIndex)
            {
                case 0: WordToBinStr(*LPWORD(buf), buf); break;
                case 1: WordToOctStr(*LPWORD(buf), buf); break;
                case 2: wsprintf(buf, "%lu", *LPWORD(buf)); break;
                case 3: wsprintf(buf, "%04X", *LPWORD(buf));
            }
            break;
        case 2:
            switch (RadixList->ItemIndex)
            {
                case 0: DWordToBinStr(*LPDWORD(buf), buf); break;
                case 1: DWordToOctStr(*LPDWORD(buf), buf); break;
                case 2: wsprintf(buf, "%lu", *LPDWORD(buf)); break;
                case 3: wsprintf(buf, "%08X", *LPDWORD(buf));
            }
            break;
        case 3:
            sprintf(buf, "%f", *(float *)(buf));
            break;
        case 4:
            sprintf(buf, "%f", *(double *)(buf));
            break;
        case 5:
            break;
        case 6:
        {
            char t_buf[256];
            BOOL UseDefChar = TRUE;
            CHAR DefChar = 0;
            ZeroMemory(t_buf, sizeof(t_buf));
            WideCharToMultiByte(CP_ACP, 0, (LPWSTR)buf, -1, t_buf,
                sizeof(t_buf), &DefChar, &UseDefChar);
            lstrcpy(buf, t_buf);
            break;
        }
    }
    Val->Text = (char *)buf;
}
//---------------------------------------------------------------------------
bool __fastcall TEditMemDlg::SetData()
{
    char buf[1024], *q = buf;
    DWORD dwSize = 0;
    char TextBuf[256], *p = TextBuf;
    lstrcpy(TextBuf, Val->Text.c_str());
    if (TypesList->ItemIndex == 5)
    {
        lstrcpy(buf, p);
        dwSize = lstrlen(buf);
    }
    else if (TypesList->ItemIndex == 6)
    {
        MultiByteToWideChar(CP_ACP, 0, p, -1, (LPWSTR)buf, sizeof(buf));
        dwSize = lstrlenW((LPWSTR)buf) * sizeof(WCHAR);
    }
    else
    {
        char buf[256], *t;
        while (p)
        {
            while (*p == ' ' || *p == '\t' || *p == '\n' || *p == '\r') p++;
            t = buf;
            *t = 0;
            while (*p && *p != ' ' && *p != '\t' && *p != '\n' && *p != '\r')
                *t++ = *p++;
            *t = 0;
            if (!buf[0]) break;
            if (TypesList->ItemIndex < 3)
            {
                DWORD dw;
                switch (RadixList->ItemIndex)
                {
                    case 0:
                        if (!BinStrToDWord(buf, &dw))
                            return false;
                        break;
                    case 1:
                        if (!OctStrToDWord(buf, &dw))
                            return false;
                        break;
                    case 2:
                        if (!DecStrToDWord(buf, &dw))
                            return false;
                        break;
                    case 3:
                        if (!HexStrToDWord(buf, &dw))
                            return false;
                }
                switch (TypesList->ItemIndex)
                {
                    case 0:
                        *q = (BYTE)dw;
                        dwSize++;
                        q++;
                        break;
                    case 1:
                        *LPWORD(q) = (WORD)dw;
                        dwSize += 2;
                        q += 2;
                        break;
                    case 2:
                        *LPDWORD(q) = (DWORD)dw;
                        dwSize += 4;
                        q += 4;
                }
            }
            else
            {
                double t = atof(buf);
                if (TypesList->ItemIndex == 3)
                {
                    *(float *)q = t;
                    dwSize += 4;
                    q += 4;
                }
                else
                {
                    *(double *)q = t;
                    dwSize += 8;
                    q += 8;
                }
            }
        }
    }

    HANDLE hProcess = INVALID_HANDLE_VALUE;
    if ((hProcess = OpenProcess(PROCESS_VM_WRITE | PROCESS_VM_OPERATION,
        FALSE, ProcessId)) != INVALID_HANDLE_VALUE)
    {
        DWORD OldProtect, Err;
        VirtualProtectEx(hProcess, Addr, dwSize, PAGE_READWRITE, &OldProtect);
        if (WriteProcessMemory(hProcess, Addr, buf, dwSize, NULL))
        {
            VirtualProtectEx(hProcess, Addr, dwSize, OldProtect, &OldProtect);
            CloseHandle(hProcess);
            return true;
        }
    }

    ShowGUIError(Handle, "   ");
    CloseHandle(hProcess);

    return true;
}
//---------------------------------------------------------------------------
void __fastcall TEditMemDlg::RadixListChange(TObject *Sender)
{
    GetData();
}
//---------------------------------------------------------------------------
void __fastcall TEditMemDlg::Button1Click(TObject *Sender)
{
    LPVOID TempAddr = NULL;
    char buf[64];
    sscanf(AddrEdit->Text.c_str(), "%08X", &TempAddr);
    Addr = TempAddr;
    GetData();
    wsprintf(buf, "%08X", Addr);
    AddrEdit->Text = buf;
}
//---------------------------------------------------------------------------
void __fastcall TEditMemDlg::ValKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if (Key == VK_RETURN) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TEditMemDlg::OKBtnClick(TObject *Sender)
{
    if (!SetData())
    {
        Application->MessageBox("    \n\
   ", "", MB_OK | MB_ICONEXCLAMATION);
        return;
    }
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------

