//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TModSearchDlg.h"
#include "Process.h"
#include "Utils.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TModSearchDlg *ModSearchDlg;
int _LastCol = -1, _OrderBy = 1;
bool _IsNumberCol[4] = {0,0,1,0};
//---------------------------------------------------------------------
__fastcall TModSearchDlg::TModSearchDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TModSearchDlg::FormShow(TObject *Sender)
{
    ModsList->Items->Clear();
    ModName->SetFocus();
}
//---------------------------------------------------------------------------
VOID WINAPI SearchProc(LPTSTR lpszModName, LPTSTR lpszProcName, DWORD pid,
    LPTSTR lpszPath, LPVOID lpParam)
{
    TListView *lv = (TListView *)lpParam;
    TListItem *li = lv->Items->Add();
    li->Caption = lpszModName;
    li->SubItems->Add(lpszProcName);
    li->SubItems->Add(pid);
    li->SubItems->Add(lpszPath);
    li->Data = (void *)pid;
}
//---------------------------------------------------------------------------
int __stdcall _CustomSortProc(long Item1, long Item2, long ParamSort)
{
    int res, n = (ParamSort & 0xFF), OrderBy = ParamSort >> 16;
    int k = (ParamSort & 0xFF00) >> 8;
    TListItem *li1 = (TListItem *)Item1, *li2 = (TListItem *)Item2;

    if (!n)
        res = MyCompareStr(li1->Caption.c_str(),
            li2->Caption.c_str(), _IsNumberCol[k]);
    else
        res = MyCompareStr(li1->SubItems->Strings[n - 1].c_str(),
            li2->SubItems->Strings[n - 1].c_str(), _IsNumberCol[k]);

    return res * OrderBy;
}
//---------------------------------------------------------------------------
void __fastcall TModSearchDlg::SearchBtnClick(TObject *Sender)
{
    ModsList->Items->Clear();
    if (ExtractFileExt(ModName->Text).IsEmpty())
    {
    	ModName->Text = ModName->Text + ".dll";
    }
    if (!SearchForModule(ModName->Text.c_str(), SearchProc, ModsList))
    {
        ShowGUIError(Handle, "   ");
        return;
    }
    if (!ModsList->Items->Count)
    {
        Application->MessageBox(
            "      ",
            " ", MB_OK | MB_ICONINFORMATION);
    }
    else if (_LastCol >= 0)
    {
        ModsList->CustomSort(_CustomSortProc, _LastCol |
            (ModsList->Columns->Items[_LastCol]->Tag << 8) | (_OrderBy << 16));
    }
}
//---------------------------------------------------------------------------
void __fastcall TModSearchDlg::ModsListSelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
    TerminateBtn->Enabled = Selected;
}
//---------------------------------------------------------------------------
void __fastcall TModSearchDlg::TerminateBtnClick(TObject *Sender)
{
    if (Application->MessageBox("  ?",
        "", MB_YESNO | MB_ICONWARNING) != IDYES) return;
    int i = 0, k = ModsList->Items->Count;
    for (; i < k; i++)
    {
        if (!ModsList->Items->Item[i]->Selected) continue;
        KillProcess((DWORD)ModsList->Items->Item[i]->Data);
        ModsList->Items->Delete(i);
        i--;
        k--;
    }
}
//---------------------------------------------------------------------------
void __fastcall TModSearchDlg::ModsListColumnClick(TObject *Sender,
      TListColumn *Column)
{
    int index = Column->Index;
    _OrderBy = index == _LastCol ? _OrderBy * -1 : 1;
    ModsList->CustomSort(_CustomSortProc, index |
        (Column->Tag << 8) | (_OrderBy << 16));
    _LastCol = index;
}
//---------------------------------------------------------------------------

