//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TModsForm.h"
#include "Main.h"
#include "Process.h"
#include "TSaveTableDlg.h"
#include "TVersionDlg.h"
#include "Utils.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Placemnt"
#pragma resource "*.dfm"
TModsForm *ModsForm;
//---------------------------------------------------------------------------
__fastcall TModsForm::TModsForm(TComponent* Owner)
    : TForm(Owner)
{
    LastCol = 0;
    OrderBy = 1;
}
//---------------------------------------------------------------------------
VOID WINAPI EnumProc(LPTSTR szModName, LPVOID lpBaseOfDll,
    DWORD SizeOfImage, LPVOID lpParam)
{
    TListView *list = (TListView *)lpParam;
    TListItem *li = list->Items->Add();
    char buf[256];

    li->Caption = ExtractFileName(szModName).c_str();
    wsprintf(buf, "0x%08X", lpBaseOfDll);
    li->SubItems->Add(buf);
    FormatSize(buf, SizeOfImage);
    li->SubItems->Add(buf);
    GetFileCreateDateTime(szModName, buf);
    li->SubItems->Add(buf);
    li->SubItems->Add(szModName);
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::SetProcess(TMyProcess *prc)
{
    Process = prc;
    if (!prc)
    {
        ModsList->Items->Clear();
        Caption = "";
        StatusBar->SimpleText = "";
        return;
    }
    RefreshList();
}
//---------------------------------------------------------------------------
int __stdcall CustomSortProc2(long Item1, long Item2, long ParamSort)
{
    int res, n = (ParamSort & 0xFFFF), OrderBy = ParamSort >> 16;
    TListItem *li1 = (TListItem *)Item1, *li2 = (TListItem *)Item2;

    if (!n)
        res = MyCompareStr(li1->Caption.c_str(),
            li2->Caption.c_str(), false);
    else
        res = MyCompareStr(li1->SubItems->Strings[n - 1].c_str(),
            li2->SubItems->Strings[n - 1].c_str(), n == 2);

    return res * OrderBy;
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::SortColumn(int Col, int OrderBy)
{
    int i = 0, k = ModsList->Columns->Count;
    LVCOLUMN col;
    for (; i < k; i++)
    {
        col.mask = LVCF_FMT;
        col.fmt = 0;
        if (i == Col)
        {
            col.fmt |=
                LVCFMT_BITMAP_ON_RIGHT |
                LVCFMT_COL_HAS_IMAGES |
                LVCFMT_IMAGE;
            col.mask |= LVCF_IMAGE;
            col.iImage = OrderBy > 0 ? 5 : 6;
        }
        ListView_SetColumn(ModsList->Handle, i, &col);
    }
    ModsList->CustomSort(CustomSortProc2, Col | (OrderBy << 16));
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::ModsListColumnClick(TObject *Sender,
      TListColumn *Column)
{
    int index = Column->Index;
    OrderBy = index == LastCol ? OrderBy * -1 : 1;
    SortColumn(index, OrderBy);
    LastCol = index;
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::FormResize(TObject *Sender)
{
    ToolBar->Width = ControlBar->ClientWidth;
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::StayOnTopBtnClick(TObject *Sender)
{
    SetStayOnTop(Handle, StayOnTopBtn->Down);
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::CopyBtnClick(TObject *Sender)
{
    CopyStringToClipboard(ModsList->Selected->SubItems->Strings[
        ModsList->Columns->Count - 2].c_str());
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::ModsListSelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
    CopyBtn->Enabled = Selected;
    iCopy->Enabled = Selected;
    VerInfoBtn->Enabled = Selected;
    iVerInfo->Enabled = Selected;
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::SaveBtnClick(TObject *Sender)
{
    SaveTableDlg->Save(ModsList);
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::VerInfoBtnClick(TObject *Sender)
{
    VersionDlg->ShowVersionInfo(ModsList->Selected->SubItems->Strings[
        ModsList->Columns->Count - 2]);
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    MainForm->iModsList->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::RefreshBtnClick(TObject *Sender)
{
    RefreshList();
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::RefreshList()
{
    ModsList->Items->Clear();
    if (!Process) return;
    ModsList->Enabled = Process->pid;
    if (IsWinNT())
        EnumModulesNt(Process->pid, EnumProc, ModsList);
    else
        EnumModules9x(Process->pid, EnumProc, ModsList);
    char buf[MAX_PATH + 64];
    wsprintf(buf, "  \"%s\" (PID=%lu)",
        Process->ProcessName, Process->pid);
    Caption = buf;
    SortColumn(LastCol, OrderBy);
    StatusBar->SimpleText = AnsiString(" : ") +
        ModsList->Items->Count;
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::ModsListKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch (Key)
    {
        case VK_F5:
            RefreshList();
            break;
        case 'S':
            if (Shift.Contains(ssCtrl))
                SaveBtnClick(NULL);
            break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::iCopyClick(TObject *Sender)
{
    if (CopyBtn->Enabled) CopyBtnClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::iVerInfoClick(TObject *Sender)
{
    if (VerInfoBtn->Enabled) VerInfoBtnClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TModsForm::iPropertiesClick(TObject *Sender)
{
    ShowFileProperties(ModsList->Selected->SubItems->Strings[3].c_str());
}
//---------------------------------------------------------------------------

