//---------------------------------------------------------------------------

#ifndef TViewMemFormH
#define TViewMemFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "MyProcess.h"
#include <ComCtrls.hpp>
#include <Grids.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Placemnt.hpp"
//---------------------------------------------------------------------------
class TViewMemForm : public TForm
{
__published:	// IDE-managed Components
    TStatusBar *StatusBar1;
    TStringGrid *MemGrid;
    TListView *RegsList;
    TImageList *ImageList;
    TBevel *Bevel1;
    TStatusBar *StatusBar2;
    TControlBar *ControlBar;
    TToolBar *ToolBar;
    TToolButton *EditBtn;
    TToolButton *SearchBtn;
    TToolButton *GotoBtn;
    TToolButton *SearchAgainBtn;
    TToolButton *ToolButton1;
    TToolButton *ToolButton2;
    TToolButton *ToolButton3;
	TFormStorage *FormStorage1;
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall MemGridDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
    void __fastcall RegsListSelectItem(TObject *Sender, TListItem *Item,
          bool Selected);
    void __fastcall MemGridSelectCell(TObject *Sender, int ACol, int ARow,
          bool &CanSelect);
    void __fastcall MemGridDblClick(TObject *Sender);
    void __fastcall MemGridKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall EditBtnClick(TObject *Sender);
    void __fastcall GotoBtnClick(TObject *Sender);
    void __fastcall SearchBtnClick(TObject *Sender);
    void __fastcall SearchAgainBtnClick(TObject *Sender);
    void __fastcall ToolButton2Click(TObject *Sender);
    void __fastcall RegsListKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
private:	// User declarations
    TMyProcess *Process;
    HANDLE hProcess;
    LPBYTE Cache, CacheAddr;
    LPBYTE CurRegion;
    LPBYTE LastFoundAddr;
    DWORD CurRegionSize;
    DWORD VMSize;
    BOOL WasRead;
    void __fastcall ReadCache();
    inline BYTE GetFromCache(LPBYTE Addr);
    void __fastcall UpdateRegionInfo(LPBYTE Addr);
    inline LPBYTE __fastcall GetAddr(DWORD Row, DWORD Col);
    void __fastcall EditMem();
    void __fastcall Search(LPBYTE lpStartAddr);
public:		// User declarations
    __fastcall TViewMemForm(TComponent* Owner, TMyProcess *prc);
    __fastcall ~TViewMemForm();
    void __fastcall RefreshList();
    friend VOID WINAPI EnumProc2(PMEMORY_BASIC_INFORMATION mem, LPVOID lpParam);
};
//---------------------------------------------------------------------------
extern PACKAGE TViewMemForm *ViewMemForm;
//---------------------------------------------------------------------------
#endif
