.386
.model flat, stdcall

.code

locals @@

CPU_ID MACRO
	DB 0Fh, 0A2h
ENDM


CPUID_VENDOR_ID_LENGTH EQU 12

PUBLIC CPUID_IsAvailable
PUBLIC CPUID_GetMaxFuncNumber
PUBLIC CPUID_GetMaxFuncNumberEx
PUBLIC CPUID_GetVendorID
PUBLIC CPUID_GetProcessorMiscInfo
PUBLIC CPUID_GetBrandString
PUBLIC CPUID_GetProcessorSignature
PUBLIC CPUID_GetProcessorFeatures
PUBLIC CPUID_GetProcessorFeaturesEx
PUBLIC CPUID_GetSerialNumber
PUBLIC CPUID_GetIntelCacheInfo
PUBLIC CPUID_GetAMDL1CacheInfo
PUBLIC CPUID_GetAMDL2CacheInfo
PUBLIC CPUID_GetAMDAPMFeatures
PUBLIC CPUID_GetAMDAddressRangeInfo


CPUID_IsAvailable PROC
		push	ecx
		pushfd
		pop		eax
		mov		ecx, eax
		xor		eax, 200000h
		push	eax
		popfd
		pushfd
		pop		eax
		xor		eax, ecx
		setne	al
		movzx	eax, al
		pop		ecx
		ret
CPUID_IsAvailable ENDP


CPUID_GetMaxFuncNumber PROC
		push	ebx
		push	ecx
		push	edx
		xor		eax, eax
		CPU_ID
		pop		edx
		pop		ecx
		pop		ebx
		ret
CPUID_GetMaxFuncNumber ENDP


CPUID_GetMaxFuncNumberEx PROC
		push	ebx
		push	ecx
		push	edx
		mov		eax, 80000000h
		CPU_ID
		pop		edx
		pop		ecx
		pop		ebx
		ret
CPUID_GetMaxFuncNumberEx ENDP


CPUID_GetVendorID PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		xor		eax, eax
		CPU_ID
		mov		edi, [ebp+8]
		mov		[edi], ebx
		mov		[edi+4], edx
		mov		[edi+8], ecx
		mov		byte ptr [edi+CPUID_VENDOR_ID_LENGTH], 0
		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetVendorID ENDP


CPUID_GetProcessorMiscInfo PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		eax, 00000001h
		CPU_ID
		mov		edi, [ebp+8]
		mov		[edi], ebx
		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetProcessorMiscInfo ENDP


CPUID_GetBrandString PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		edi, [ebp+8]
		mov		eax, 80000002h
		CPU_ID
		mov		[edi], eax
		mov		[edi+4], ebx
		mov		[edi+8], ecx
		mov		[edi+12], edx
		mov		eax, 80000003h
		CPU_ID
		mov		[edi+16], eax
		mov		[edi+20], ebx
		mov		[edi+24], ecx
		mov		[edi+28], edx
		mov		eax, 80000004h
		CPU_ID
		mov		[edi+32], eax
		mov		[edi+36], ebx
		mov		[edi+40], ecx
		mov		[edi+44], edx
		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetBrandString ENDP


CPUID_GetProcessorSignature PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		eax, 00000001h
		CPU_ID
		mov		edi, [ebp+8]
		mov		[edi], eax
		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetProcessorSignature ENDP


CPUID_GetProcessorFeatures PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		eax, 00000001h
		CPU_ID
		mov		edi, [ebp+8]
		or		edi, edi
		jz		skip
		mov		[edi], edx
skip:	mov		eax, edx
		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetProcessorFeatures ENDP


CPUID_GetProcessorFeaturesEx PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		eax, 00000001h
		CPU_ID
		mov		edi, [ebp+8]
		mov		eax, ecx
		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetProcessorFeaturesEx ENDP


CPUID_GetSerialNumber PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		edi, [ebp+8]
		mov		eax, 00000001h
		CPU_ID
		mov		[edi+8], eax
		mov		eax, 00000003h
		CPU_ID
		mov		[edi+4], edx
		mov		[edi], ecx
		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetSerialNumber ENDP


CPUID_GetIntelCacheInfo PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		edi, [ebp+8]
		cld
		mov		eax, 00000002h
		CPU_ID
		movzx	esi, al
		push	eax
		mov		eax, [ebp+12]
		imul	esi, esi, 15
		mov		[eax], esi
		pop		eax
		or		esi, esi
		jz		m2
m1:		or		eax, eax
		js		skip1
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
skip1:	mov		eax, ebx
		or		eax, eax
		js		skip2
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
skip2:	mov		eax, ecx
		or		eax, eax
		js		skip3
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
skip3:	mov		eax, edx
		or		eax, eax
		js		skip4
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
		ror		eax, 8
		stosb
skip4:	dec		esi
		jz		m2
		mov		eax, 00000002h
		CPU_ID
		jmp		m1
m2:		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetIntelCacheInfo ENDP


CPUID_GetAMDL1CacheInfo PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		eax, 80000005h
		CPU_ID
		mov		edi, [ebp+8]
		or		edi, edi
		jz		@@m1
		mov		[edi], eax
@@m1:	mov		edi, [ebp+12]
		or		edi, edi
		jz		@@m2
		mov		[edi], ebx
@@m2:	mov		edi, [ebp+16]
		or		edi, edi
		jz		@@m3
		mov		[edi], ecx
@@m3:	mov		edi, [ebp+20]
		or		edi, edi
		jz		@@m4
		mov		[edi], edx
@@m4:	pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetAMDL1CacheInfo ENDP


CPUID_GetAMDL2CacheInfo PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		eax, 80000006h
		CPU_ID
		mov		edi, [ebp+8]
		or		edi, edi
		jz		@@m1
		mov		[edi], eax
@@m1:	mov		edi, [ebp+12]
		or		edi, edi
		jz		@@m2
		mov		[edi], ebx
@@m2:	mov		edi, [ebp+16]
		or		edi, edi
		jz		@@m3
		mov		[edi], ecx
@@m3:	mov		edi, [ebp+20]
		or		edi, edi
		jz		@@m4
		mov		[edi], edx
@@m4:	pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetAMDL2CacheInfo ENDP


CPUID_GetAMDAPMFeatures PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		eax, 80000007h
		CPU_ID
		mov		edi, [ebp+8]
		mov		[edi], edx
		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetAMDAPMFeatures ENDP


CPUID_GetAMDAddressRangeInfo PROC
		push	ebp
        mov		ebp, esp
		push	ebx
		push	ecx
		push	edx
		push	edi
		mov		eax, 80000008h
		CPU_ID
		mov		edi, [ebp+8]
		mov		[edi], eax
		pop		edi
		pop		edx
		pop		ecx
		pop		ebx
        pop		ebp
		ret
CPUID_GetAMDAddressRangeInfo ENDP


end
